// addpathjdk.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <windows.h>

#pragma comment (lib, "AdvAPI32.Lib")

typedef const TCHAR Text;
#define null NULL

#define OUT_LENGTH 1024

class Reg {
public:
	static boolean writeKey(HKEY key, Text* subkey, Text* name, Text* value) {
		HKEY keyres = createKey(key, subkey, KEY_WRITE);
		boolean b = writeString(keyres, name, value);
		closeKey(keyres);
		return b;
	}
	static boolean readKey(HKEY key, Text* subkey, Text* name, TCHAR* outValue) {
		HKEY keyres = createKey(key, subkey, KEY_READ);
		boolean b = readString(keyres, name, outValue);
		closeKey(keyres);
		return b;
	}
	// key : HKEY_CLASSES_ROOT, HKEY_CURRENT_USER, HKEY_LOCAL_MACHINE, HKEY_USERS
	static boolean deleteValue(HKEY key, Text* subkey, Text* name) {
		HKEY keyres = createKey(key, subkey, KEY_ALL_ACCESS);
		deleteValue(keyres, name);
		closeKey(keyres);
		return true;
	}
protected:
	static boolean deleteKey(HKEY key, Text* subkey) {
		if (key == null)
			return true;
		return RegDeleteKey(key, subkey) == ERROR_SUCCESS;
	}
	static boolean deleteValue(HKEY key, Text* name) {
		if (key == null)
			return true;
		return RegDeleteValue(key, name) == ERROR_SUCCESS;
	}
	// key : HKEY_CLASSES_ROOT, HKEY_CURRENT_USER, HKEY_LOCAL_MACHINE, HKEY_USERS
	// desired : KEY_ALL_ACCESS, KEY_CREATE_LINK, KEY_CREATE_SUB_KEY, KEY_READ, KEY_WRITE, KEY_SET_VALUE
	static HKEY createKey(HKEY key, Text* subkey, DWORD desired) {
		if (key == null)
			return null;
		HKEY keyres;
		DWORD disposition;
		if (RegCreateKeyEx(key, subkey, 0, null, 0, desired, null, &keyres, &disposition) != ERROR_SUCCESS)
			return null;
		// disposition == REG_CREATED_NEW_KEY || REG_OPENED_EXISTING_KEY
		return keyres;
	}
	static boolean writeString(HKEY key, Text* name, Text* value) {
		if (key == null)
			return true;
		return RegSetValueEx(key, name, 0, REG_SZ, (CONST BYTE*)value, (int)_tcslen(value) * 2) == ERROR_SUCCESS;
	}
	static boolean readString(HKEY key, Text* name, TCHAR* outValue) {
		if (key == null)
			return true;
		DWORD len = OUT_LENGTH;
		DWORD type = REG_SZ;
		
		LONG res = RegQueryValueEx(key, name, 0, &type, (LPBYTE)outValue, &len);
		boolean b = res == ERROR_SUCCESS;
		return b;
	}
	static void closeKey(HKEY key) {
		if (key == null)
			return;
		RegCloseKey(key);
	}
	//--
	static int length(Text* s) {
		return (int)_tcslen(s);
	}
};

int indexOf(TCHAR* base, TCHAR* s) {
	int off = 0;
	int slen = (int)_tcslen(base);
	int len = (int)_tcslen(s);
	for (int i = off; i <= slen - len; i++) {
		int j = 0;
		for (j = 0; j < len; j++) {
			if (base[i + j] != s[j])
				break;
		}
		if (j == len)
			return i;
	}
	return -1;
}

#define ADDPATH TEXT("C:\\Program Files\\Java\\jdk1.6.0_04\\bin")

int _tmain(int argc, _TCHAR* argv[]) {
	TCHAR buf[OUT_LENGTH];

	if (Reg::readKey(HKEY_CURRENT_USER, TEXT("Environment"), TEXT("path"), buf))
		;//printf(buf);
	
	if (_tcslen(buf) > 0) {
		_tcscat(buf, TEXT(";"));
	}
	// ԍŐV擾
	if (indexOf(buf, ADDPATH) != -1) {
		return 0; // ɓĂ
	}
	_tcscat(buf, ADDPATH);

//	if (Reg::writeKey(HKEY_CURRENT_USER, TEXT("Environment"), TEXT("testfromvc"), TEXT("testtest")))
	if (Reg::writeKey(HKEY_CURRENT_USER, TEXT("Environment"), TEXT("path"), buf))
		; //MessageBox(NULL, "addpath", "ok", MB_OK);
}

